Package org.optaplanner.core.impl.score.stream.drools.bi

## Class DroolsGroupingBiConstraintStream<Solution_,​NewA,​NewB>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.bi.DroolsAbstractBiConstraintStream<Solution_,​NewA,​NewB>
      - - org.optaplanner.core.impl.score.stream.drools.bi.DroolsGroupingBiConstraintStream<Solution_,​NewA,​NewB>

- All Implemented Interfaces:
    `BiConstraintStream<NewA,​NewB>`, `ConstraintStream`, `InnerBiConstraintStream<NewA,​NewB>`

      public class DroolsGroupingBiConstraintStream<Solution_,​NewA,​NewB>
      extends DroolsAbstractBiConstraintStream<Solution_,​NewA,​NewB>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyAMapping, BiFunction<A,​B,​NewB> groupKeyBMapping)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, BiFunction<A,​B,​NewA> groupKeyMapping, BiConstraintCollector<A,​B,​__,​NewB> collector)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping, QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent, QuadFunction<A,​B,​C,​D,​NewA> groupKeyMapping, QuadConstraintCollector<A,​B,​C,​D,​__,​NewB> collector)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyAMapping, TriFunction<A,​B,​C,​NewB> groupKeyBMapping)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriFunction<A,​B,​C,​NewA> groupKeyMapping, TriConstraintCollector<A,​B,​C,​__,​NewB> collector)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyAMapping, Function<A,​NewB> groupKeyBMapping)` |
    `DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractUniConstraintStream<Solution_,​A> parent, Function<A,​NewA> groupKeyMapping, UniConstraintCollector<A,​__,​NewB> collector)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DroolsBiCondition<NewA,​NewB,​?>` | `getCondition()` |
    `protected DroolsAbstractConstraintStream<Solution_>` | `getParent()` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.bi.DroolsAbstractBiConstraintStream

      `filter, getCardinality, getFromStreamList, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, createRuleItemBuilders, getChildStreams, getConstraintFactory, getExpectedJustificationTypes`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.bi.BiConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.bi.InnerBiConstraintStream

      `impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                  Function<A,​NewA> groupKeyAMapping,
                                                  Function<A,​NewB> groupKeyBMapping)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractUniConstraintStream<Solution_,​A> parent,
                                                  Function<A,​NewA> groupKeyMapping,
                                                  UniConstraintCollector<A,​__,​NewB> collector)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                  BiFunction<A,​B,​NewA> groupKeyMapping,
                                                  BiConstraintCollector<A,​B,​__,​NewB> collector)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                                  BiFunction<A,​B,​NewA> groupKeyAMapping,
                                                  BiFunction<A,​B,​NewB> groupKeyBMapping)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                  TriFunction<A,​B,​C,​NewA> groupKeyMapping,
                                                  TriConstraintCollector<A,​B,​C,​__,​NewB> collector)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                  TriFunction<A,​B,​C,​NewA> groupKeyAMapping,
                                                  TriFunction<A,​B,​C,​NewB> groupKeyBMapping)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                  QuadFunction<A,​B,​C,​D,​NewA> groupKeyMapping,
                                                  QuadConstraintCollector<A,​B,​C,​D,​__,​NewB> collector)

    - #### DroolsGroupingBiConstraintStream

          public DroolsGroupingBiConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                  DroolsAbstractQuadConstraintStream<Solution_,​A,​B,​C,​D> parent,
                                                  QuadFunction<A,​B,​C,​D,​NewA> groupKeyAMapping,
                                                  QuadFunction<A,​B,​C,​D,​NewB> groupKeyBMapping)

  - ### Method Detail

    - #### getCondition

          public DroolsBiCondition<NewA,​NewB,​?> getCondition()

      Specified by:
        `getCondition` in class `DroolsAbstractBiConstraintStream<Solution_,​NewA,​NewB>`

    - #### getParent

          protected DroolsAbstractConstraintStream<Solution_> getParent()

      Specified by:
        `getParent` in class `DroolsAbstractBiConstraintStream<Solution_,​NewA,​NewB>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`